=== debian/changelog ===
macromoleculebuilder (4.0.0+dfsg-5) unstable; urgency=medium

  * Link MMB_SHARED_TARGET with ZLIB_LIBRARIES via patch (Closes: #1086362)

 -- Andrius Merkys <merkys@debian.org>  Wed, 27 Nov 2024 02:07:37 -0500

macromoleculebuilder (4.0.0+dfsg-4) unstable; urgency=medium

  * Acknowledge NMU.
  * Limit build architectures to 64bit (Closes: #1068925)

 -- Andrius Merkys <merkys@debian.org>  Thu, 02 May 2024 09:49:15 -0400
