=== debian/control ===
Source: macromoleculebuilder
Priority: optional
Section: science
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 architecture-is-64-bit,
 asciidoc-base,
 cmake,
 debhelper-compat (= 13),
 docbook-xml,
 dpkg-dev (>= 1.22.5),
 gemmi-dev (>= 0.6.2+ds-2),
 libopenmm-dev,
 libseqan2-dev,
 libsimbody-dev,
 libsimtkmolmodel-dev (>= 3.1.0),
 libsimtkmolmodel-plugins,
 libstb-dev,
 tao-pegtl-dev,
 zlib1g-dev,
Standards-Version: 4.6.2
Homepage: https://simtk.org/projects/rnatoolbox
Vcs-Browser: https://salsa.debian.org/debichem-team/macromoleculebuilder
Vcs-Git: https://salsa.debian.org/debichem-team/macromoleculebuilder.git
Rules-Requires-Root: no

Package: libmmb-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libmmb4.0t64 (= ${binary:Version}),
 ${misc:Depends},
Breaks:
 libmmblib-dev (<< 4.0.0),
Replaces:
 libmmblib-dev (<< 4.0.0),
Description: development files of MacroMoleculeBuilder
 MacroMoleculeBuilder, previously known as RNABuilder, can be used for morphing,
 homology modeling, folding (e.g. using base pairing contacts), redesigning
 complexes, fitting to low-resolution density maps, predicting local
 rearrangements upon mutation, and many other applications.
 .
 This package contains the development files.

Package: libmmb4.0t64
Provides: ${t64:Provides}
Replaces: libmmb4.0
Breaks: libmmb4.0 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: shared library of MacroMoleculeBuilder
 MacroMoleculeBuilder, previously known as RNABuilder, can be used for morphing,
 homology modeling, folding (e.g. using base pairing contacts), redesigning
 complexes, fitting to low-resolution density maps, predicting local
 rearrangements upon mutation, and many other applications.
 .
 This package contains the shared library.

Package: mmb
Architecture: any
Depends:
 mmb-common,
 ${misc:Depends},
 ${shlibs:Depends},
Description: model the structure and dynamics of macromolecules
 MacroMoleculeBuilder, previously known as RNABuilder, can be used for morphing,
 homology modeling, folding (e.g. using base pairing contacts), redesigning
 complexes, fitting to low-resolution density maps, predicting local
 rearrangements upon mutation, and many other applications.

Package: mmb-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: model the structure and dynamics of macromolecules (common files)
 MacroMoleculeBuilder, previously known as RNABuilder, can be used for morphing,
 homology modeling, folding (e.g. using base pairing contacts), redesigning
 complexes, fitting to low-resolution density maps, predicting local
 rearrangements upon mutation, and many other applications.
 .
 This package contains common files.
