=== debian/changelog ===
macromoleculebuilder (4.2+dfsg-2) unstable; urgency=medium

  * Rename build dependency gemmi-dev -> libgemmi-dev (Closes: 1123836)
  * Fix incompatibility with seqan2 >= 2.5.0.

 -- Andrius Merkys <merkys@debian.org>  Thu, 15 Jan 2026 05:05:05 -0500

macromoleculebuilder (4.2+dfsg-1) unstable; urgency=medium

  * New upstream release 4.2+dfsg (Closes: #1113261)
  * Update file exclusion list.
  * Review patches.
  * Fix incompatibility with gemmi >= 0.7.0 (Closes: #1114196)
  * Adjust to soname change.

 -- Andrius Merkys <merkys@debian.org>  Fri, 21 Nov 2025 07:44:58 -0500
