=== debian/control ===
--- 
+++ 
@@ -11,9 +11,9 @@
  debhelper-compat (= 13),
  docbook-xml,
  dpkg-dev (>= 1.22.5),
- gemmi-dev (>= 0.6.2+ds-2),
+ libgemmi-dev (>= 0.6.2+ds-2),
  libopenmm-dev,
- libseqan2-dev,
+ libseqan2-dev (>= 2.5.0),
  libsimbody-dev,
  libsimtkmolmodel-dev (>= 3.1.0),
  libsimtkmolmodel-plugins,
@@ -31,7 +31,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libmmb4.0t64 (= ${binary:Version}),
+ libmmb4.1 (= ${binary:Version}),
  ${misc:Depends},
 Breaks:
  libmmblib-dev (<< 4.0.0),
@@ -45,10 +45,7 @@
  .
  This package contains the development files.
 
-Package: libmmb4.0t64
-Provides: ${t64:Provides}
-Replaces: libmmb4.0
-Breaks: libmmb4.0 (<< ${source:Version})
+Package: libmmb4.1
 Section: libs
 Architecture: any
 Multi-Arch: same
